BuildRequires: jpackage-1.4-compat
Name: tomcat4
Version: 4.1.31
Release: alt5.3

%def_enable check
%def_disable debug
%def_with jdbc

Summary: Apache Tomcat Servlet/JSP Engine
License: Apache
Group: Development/Java
URL: http://jakarta.apache.org/tomcat/

%define tomcat_home %_libdir/%name
%define tomcat_user tomcat
%define tomcat_group apache
%define pkgdocdir %_docdir/tomcat-%version

Source0: jakarta-tomcat-%version-src.tar.bz2
Source1: jakarta-tomcat-connectors-%version-src.tar.bz2
Source2: %name-build.properties
Source3: %name-server.xml
Source4: %name-webapps-admin.xml
Source5: %name-webapps-manager.xml
Source6: %name.init
Source7: %name.conf

Patch0: jakarta-tomcat-4.1.31-alt-build.patch
Patch1: jakarta-tomcat-4.1.31-alt-security-policy.patch
Patch2: jakarta-tomcat-4.1.31-alt-no-admin-compile.patch
Patch3: jakarta-tomcat-4.1.31-jdk1.5.patch

BuildArch: noarch

BuildPreReq: rpm-build-java
BuildRequires: /proc
#BuildRequires: java-devel >= 1.4
BuildRequires: ant ant-trax
BuildRequires: common-licenses
BuildRequires: eclipse-build-utils
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-daemon
BuildRequires: jakarta-commons-digester
BuildRequires: jakarta-commons-fileupload
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-modeler
BuildRequires: regexp
BuildRequires: jakarta-servletapi4
BuildRequires: jaf javamail
BuildRequires: mx4j
%if_enabled check
BuildRequires: junit ant-junit
%endif
%if_with jdbc
BuildRequires: jakarta-commons-dbcp
BuildRequires: jakarta-commons-pool
BuildRequires: jdbc-stdext
%endif

%description
Tomcat is the servlet container that is used in the official
Reference Implementation for the Java Servlet and
JavaServer Pages technologies.
Tomcat conforms to the Servlet 2.3 and JSP 1.2 specifications.

This package contains jar archives implementing the Tomcat engine.
If you need to deploy Java web applications, install the
%name-server package.

%package manual
Summary: Manual for Tomcat
Group: Development/Java
Requires: %name-javadoc = %version-%release
Requires: jakarta-servletapi4-javadoc
AutoReqProv: no

%description manual
Documentation for Tomcat, a Java Servlet/JSP container.

%package javadoc
Summary: Javadoc for Tomcat
Group: Development/Java
AutoReqProv: no

%description javadoc
Javadoc-generated documentation for Tomcat, a Java Servlet/JSP container.

%package server
Summary: Apache Tomcat Servlet/JSP server
Group: System/Servers
Requires: %name = %version-%release
Requires: java-common >= 1.2
Requires: java
Requires: jakarta-commons-daemon-jsvc
Requires: jakarta-servletapi4
Requires: jakarta-commons-beanutils
Requires: jakarta-commons-collections
Requires: jakarta-commons-digester
Requires: jakarta-commons-fileupload
Requires: jakarta-commons-logging
Requires: jakarta-commons-modeler
Requires: regexp
# Need this for j2se 1.3?
#Requires: xerces-j
Requires: ant jaf javamail mx4j
AutoProv: no

%description server
This is the default installation of the Tomcat Servlet/JSP container.
The server is set up as a system service.

%package webapps-admin
Summary: Administration web application for Tomcat
Group: Networking/WWW
Requires: %name-server = %version-%release
Requires: struts
AutoReqProv: no

%description webapps-admin
Administration web interface for Tomcat.

%package webapps-manager
Summary: Management web application for Tomcat
Group: Networking/WWW
Requires: %name-server = %version-%release
AutoReqProv: no

%description webapps-manager
Management web interface for Tomcat.

%package webapps-examples
Summary: Example web application for Tomcat
Group: Development/Java
Requires: %name-server = %version-%release
AutoReqProv: no

%description webapps-examples
A web application for Tomcat featuring example servlets and JSP pages.

%package webapps-docs
Summary: Documentation web application for Tomcat
Group: Networking/WWW
Requires: %name-server = %version-%release
Requires: %name-manual = %version-%release
AutoReqProv: no

%description webapps-docs
Documentation for Tomcat deployed in a web application context
of the Tomcat server.

%prep
%setup -q -T -n jakarta-tomcat-%version -c -a 0 -a 1
mv jakarta-tomcat-%version-src jakarta-tomcat
mv jakarta-tomcat-connectors-%version-src jakarta-tomcat-connectors
%patch0
%patch1
%patch2
%patch3

find . -name '*.jar' -delete

cd jakarta-tomcat
cp %SOURCE2 build.properties
ln -sf %_licensedir/Apache-2.0 LICENSE
cd -

cd jakarta-tomcat-connectors
%__cp %SOURCE2 build.properties
cd -

%build
cp %_datadir/eclipse-build-utils/ant/eclipse-build-utils.xml .
%ant_build -f eclipse-build-utils.xml set-compile-version

cd jakarta-tomcat
%ant_build -Dbase.path=%_javadir \
%if_enabled debug
    -Dcompile.optimize=off \
%else
    -Dcompile.debug=off \
%endif
    dist
%if_enabled check
%ant_build -Dbase.path=%_javadir test
%endif
cd -
cd jakarta-tomcat-connectors
%ant_build javadoc
cd -

%install
cd jakarta-tomcat

# jars
%__install -d -m755 %buildroot%_javadir/%name
%__install -m644 dist/server/lib/catalina*.jar \
    %buildroot%_javadir/%name/
%__install -m644 dist/server/lib/servlets-*.jar \
    %buildroot%_javadir/%name/
%__install -m644 dist/server/lib/tomcat-*.jar \
    %buildroot%_javadir/%name/
%__install -m644 dist/common/lib/jasper-*.jar \
    %buildroot%_javadir/%name/
%__install -m644 dist/common/lib/naming-*.jar \
    %buildroot%_javadir/%name/
%__install -m644 dist/bin/{bootstrap,tomcat-jni}.jar \
    %buildroot%_javadir/%name/

# server directories
%__install -d -m755 %buildroot%tomcat_home
%__install -d -m755 %buildroot%tomcat_home/bin
%__install -m755 dist/bin/*.sh \
    %buildroot%tomcat_home/bin/
for a in bootstrap tomcat-jni; do
    %__ln_s $(relative %_javadir/%name/$a.jar %tomcat_home/bin/) \
	%buildroot%tomcat_home/bin/
done
%__ln_s $(relative %_javadir/jakarta-commons-daemon.jar %tomcat_home/bin/) \
    %buildroot%tomcat_home/bin/
%__install -d -m755 %buildroot%tomcat_home/shared
%__install -d -m755 %buildroot%tomcat_home/shared/classes
%__install -d -m755 %buildroot%tomcat_home/shared/lib
%__install -d -m755 %buildroot%tomcat_home/common
%__install -d -m755 %buildroot%tomcat_home/common/classes
%__install -d -m755 %buildroot%tomcat_home/common/endorsed
%__install -d -m755 %buildroot%tomcat_home/common/lib
for f in %buildroot%_javadir/%name/jasper-*.jar \
         %buildroot%_javadir/%name/naming-*.jar
do
    %__ln_s $(relative $f %buildroot%tomcat_home/common/lib/) \
	%buildroot%tomcat_home/common/lib/
done
for a in activation \
         ant/ant{,-launcher} \
         jakarta-commons-collections \
         jakarta-commons-logging-api \
         jakarta-servletapi4 \
         javamail/{mailapi,smtp}
do
    %__ln_s $(relative %_javadir/$a.jar %tomcat_home/common/lib/) \
	%buildroot%tomcat_home/common/lib/
done
%__install -d -m755 %buildroot%tomcat_home/server
%__install -d -m755 %buildroot%tomcat_home/server/classes
%__install -d -m755 %buildroot%tomcat_home/server/lib
for f in %buildroot%_javadir/%name/catalina*.jar \
         %buildroot%_javadir/%name/servlets-*.jar \
         %buildroot%_javadir/%name/tomcat-*.jar
do
    %__ln_s $(relative $f %buildroot%tomcat_home/server/lib/) \
	%buildroot%tomcat_home/server/lib/
done
for a in jakarta-commons-beanutils \
         jakarta-commons-digester \
         jakarta-commons-fileupload \
         jakarta-commons-logging \
         jakarta-commons-modeler \
         regexp \
         mx4j/mx4j
do
    %__ln_s $(relative %_javadir/$a.jar %tomcat_home/server/lib/) \
	%buildroot%tomcat_home/server/lib/
done

# webapps
%__cp -a dist/server/webapps %buildroot%tomcat_home/server/
%__rm -f %buildroot%tomcat_home/server/webapps/admin/WEB-INF/lib/struts.jar
%__ln_s %_javadir/struts.jar \
    %buildroot%tomcat_home/server/webapps/admin/WEB-INF/lib/
for taglib in bean html logic; do
    %__rm -f \
	%buildroot%tomcat_home/server/webapps/admin/WEB-INF/struts-$taglib.tld
    %__ln_s %_datadir/struts/struts-$taglib.tld \
	%buildroot%tomcat_home/server/webapps/admin/WEB-INF/struts-$taglib.tld
done
%__install -d -m755 %buildroot%tomcat_home/webapps
%__cp -a dist/webapps/ROOT %buildroot%tomcat_home/webapps/
%__cp -a dist/webapps/examples %buildroot%tomcat_home/webapps/
%__cp -a dist/webapps/webdav %buildroot%tomcat_home/webapps/
%__install -m640 %SOURCE4 %buildroot%tomcat_home/webapps/admin.xml
%__install -m640 %SOURCE5 %buildroot%tomcat_home/webapps/manager.xml

# docs
%__install -d -m755 %buildroot%pkgdocdir
%__cp --no-dereference LICENSE %buildroot%pkgdocdir/
%__install -m644 dist/RELEASE-NOTES* %buildroot%pkgdocdir/
%__cp -a dist/webapps/tomcat-docs/* %buildroot%pkgdocdir/
# javadocs
%__mkdir_p %buildroot%_javadocdir
for comp in catalina jasper; do
    %__mv %buildroot%pkgdocdir/$comp/docs/api \
	%buildroot%_javadocdir/%name-$comp
    %__ln_s $(relative %_javadocdir/%name-$comp %pkgdocdir/$comp/docs/) \
	%buildroot%pkgdocdir/$comp/docs/api
done
%__rm -rf %buildroot%pkgdocdir/servletapi
%__ln_s $(relative %_javadocdir/jakarta-servletapi4 %pkgdocdir/) \
    %buildroot%pkgdocdir/servletapi
# symlink from webapps to docs
%__ln_s $(relative %pkgdocdir %tomcat_home/webapps/) \
    %buildroot%tomcat_home/webapps/tomcat-docs

# runtime directories
%__install -d -m750 %buildroot%_localstatedir/%name
%__install -d -m750 %buildroot%_localstatedir/%name/conf
%__install -d -m750 %buildroot%_localstatedir/%name/work
%__install -d -m750 %buildroot%_localstatedir/%name/temp
%__install -d -m750 %buildroot%_logdir/%name

# configs
%__install -d -m755 %buildroot%_sysconfdir/%name
%__install -m640 %SOURCE3 %buildroot%_sysconfdir/%name/server.xml
%__install -m640 dist/conf/web.xml %buildroot%_sysconfdir/%name/
%__install -m640 dist/conf/catalina.policy %buildroot%_sysconfdir/%name/
%__install -m640 dist/conf/tomcat-users.xml \
    %buildroot%_localstatedir/%name/conf/
%__ln_s %_localstatedir/%name/conf/tomcat-users.xml \
    %buildroot%_sysconfdir/%name/
%__install -m640 dist/conf/jk2.properties \
    %buildroot%_localstatedir/%name/conf/
%__ln_s %_localstatedir/%name/conf/jk2.properties \
    %buildroot%_sysconfdir/%name/

cd -

# Connector javadocs
cd jakarta-tomcat-connectors
%__cp -a dist/doc/api %buildroot%_javadocdir/%name-connectors
cd -

# symlinks
%__ln_s %_sysconfdir/%name %buildroot%tomcat_home/conf
%__ln_s %_localstatedir/%name/work %buildroot%tomcat_home/work
%__ln_s %_localstatedir/%name/temp %buildroot%tomcat_home/temp
%__ln_s %_logdir/%name %buildroot%tomcat_home/logs

# init files
%__mkdir_p %buildroot%_initdir
%__install -m755 %SOURCE6 %buildroot%_initdir/%name
%__install -m640 %SOURCE7 %buildroot%_sysconfdir/%name/tomcat.conf

%pre server
%_sbindir/groupadd -r -f %tomcat_group \
    >/dev/null 2>&1 ||:
%_sbindir/useradd -r -g %tomcat_group -c "Tomcat server" -d %tomcat_home -s /dev/null -n %tomcat_user \
    >/dev/null 2>&1 ||:

%post server
%post_service %name

%preun server
%preun_service %name

%post webapps-admin
/sbin/service %name condrestart

%postun webapps-admin
[ $1 != 0 ] || /sbin/service %name condrestart

%post webapps-manager
/sbin/service %name condrestart

%postun	webapps-manager
[ $1 != 0 ] || /sbin/service %name condrestart

%post webapps-examples
/sbin/service %name condrestart

%postun webapps-examples
[ $1 != 0 ] || /sbin/service %name condrestart

%post webapps-docs
/sbin/service %name condrestart

%postun webapps-docs
[ $1 != 0 ] || /sbin/service %name condrestart

%files
%_javadir/%name
%dir %pkgdocdir
%pkgdocdir/LICENSE
%pkgdocdir/RELEASE-NOTES*

%files manual
%pkgdocdir
%exclude %pkgdocdir/LICENSE
%exclude %pkgdocdir/RELEASE-NOTES*
%exclude %pkgdocdir/WEB-INF

%files javadoc
%_javadocdir/*

%files server
%dir %tomcat_home
%tomcat_home/bin
%tomcat_home/common
%tomcat_home/shared
%dir %tomcat_home/server
%tomcat_home/server/classes
%tomcat_home/server/lib
%dir %tomcat_home/server/webapps
%dir %tomcat_home/webapps
%tomcat_home/webapps/ROOT
%tomcat_home/webapps/webdav
%tomcat_home/conf
%tomcat_home/work
%tomcat_home/temp
%tomcat_home/logs
%config %_initdir/%name
%dir %_sysconfdir/%name
%config(noreplace) %attr(640,root,%tomcat_group) %_sysconfdir/%name/tomcat.conf
%config(noreplace) %attr(640,root,%tomcat_group) %_sysconfdir/%name/server.xml
%config(noreplace) %attr(640,root,%tomcat_group) %_sysconfdir/%name/web.xml
%config(noreplace) %attr(640,root,%tomcat_group) %_sysconfdir/%name/catalina.policy
%_sysconfdir/%name/tomcat-users.xml
%_sysconfdir/%name/jk2.properties
%dir %attr(750,root,%tomcat_group) %_localstatedir/%name
%dir %attr(750,%tomcat_user,%tomcat_group) %_localstatedir/%name/conf
%config(noreplace) %attr(640,%tomcat_user,%tomcat_group) %_localstatedir/%name/conf/tomcat-users.xml
%config(noreplace) %attr(640,%tomcat_user,%tomcat_group) %_localstatedir/%name/conf/jk2.properties
%dir %attr(750,%tomcat_user,%tomcat_group) %_localstatedir/%name/work
%dir %attr(750,%tomcat_user,%tomcat_group) %_localstatedir/%name/temp
%dir %attr(750,%tomcat_user,%tomcat_group) %_logdir/%name

%files webapps-admin
%tomcat_home/server/webapps/admin
%config(noreplace) %attr(640,root,%tomcat_group) %tomcat_home/webapps/admin.xml

%files webapps-manager
%tomcat_home/server/webapps/manager
%config(noreplace) %attr(640,root,%tomcat_group) %tomcat_home/webapps/manager.xml

%files webapps-examples
%tomcat_home/webapps/examples

%files webapps-docs
%tomcat_home/webapps/tomcat-docs
%pkgdocdir/WEB-INF

%changelog
* Thu Aug 30 2007 Igor Vlasenko <viy@altlinux.ru> 4.1.31-alt5.3
- rebuild with new mx4j

* Tue Jul 03 2007 Igor Vlasenko <viy@altlinux.ru> 4.1.31-alt5.2
- now depends on regexp (no jakarta-regexp)

* Fri May 11 2007 Igor Vlasenko <viy@altlinux.ru> 4.1.31-alt5.1
- rebuild with jakarta-commons-daemon-jsvc

* Mon May 07 2007 Igor Vlasenko <viy@altlinux.ru> 4.1.31-alt5
- rebuild with java-1.4

* Fri Mar 03 2006 Mikhail Zabaluev <mhz@altlinux.ru> 4.1.31-alt4
- Patch3: fix to build with JDK 1.5

* Sun Jul 31 2005 Mikhail Zabaluev <mhz@altlinux.ru> 4.1.31-alt3
- Disabled compilation of the admin webapp due to incompatibility with
  the current version of Struts [Patch2]
- Build javadoc for connectors

* Sun Jan 23 2005 Mikhail Zabaluev <mhz@altlinux.ru> 4.1.31-alt2
- Build with JDBC by default, but do not require it at runtime

* Sun Dec 19 2004 Mikhail Zabaluev <mhz@altlinux.ru> 4.1.31-alt1
- Radically rewritten and simplified package
- Renamed to tomcat4
- Multiple instances are unsupported

* Tue Jan 20 2004 Alexey Borovskoy <alb@altlinux.ru> 4.1.29-alt1
- First build for ALTLinux
